import { EntityManagement } from '../entities';
/**
 * Main class which defined the profile management functionality
 *
 * @deprecated - Use '\@genesislcap/pbc-auth' instead.
 * 'https://www.npmjs.com/package/\@genesislcap/pbc-auth'
 * @remarks
 *
 * Under the hood the profile-management is the entity-management micro-frontend configured for use
 * with the `ALL_PROFILES` resource.
 *
 * @public
 *
 * @example
 *
 * You can use this class by forward declaring it in the template file where it is used, and then using
 * it in a html template. It is recommended to wrap it in an error boundary.
 * ```javascript
 * <profile-management></profile-management>
 * ```
 *
 */
export declare class Profiles extends EntityManagement {
    /**
     * Auth provider which is used to confirm authorisation of the user for their user management permissions
     *
     * @remarks
     *
     * Requires {@link @genesislcap/foundation-comms#Auth | the auth class} to be registered with the
     * DI container
     * @internal
     */
    private auth;
    /**
     * Constructor will set the {@link EntityManagement.createEvent} {@link EntityManagement.deleteEvent} {@link EntityManagement.updateEvent} to match the permissions set from the server
     */
    constructor();
    readProfileData(profile: any): Promise<{
        RIGHT_CODES: any[];
        USER_NAMES: any[];
        NAME: any;
    }>;
    confirmDelete(): Promise<void>;
}
//# sourceMappingURL=profiles.d.ts.map