import { Auth, Session, FoundationAnalytics } from '@genesislcap/foundation-comms';
import { Constructable } from '@microsoft/fast-element';
import { Container } from '@microsoft/fast-foundation';
import { RouterConfiguration } from '@microsoft/fast-router';
type RouterSettings = {
    public?: boolean;
    autoAuth?: boolean;
};
/**
 * Base implementation of a routing used with the Login class
 *
 * @remarks
 *
 * Could be used when using the Login class as a standalone authentication method
 * with your app
 *
 * @internal
 */
export declare class MainRouterConfig extends RouterConfiguration<RouterSettings> {
    private auth;
    private container;
    private analytics;
    private session;
    constructor(auth: Auth, container: Container, analytics: FoundationAnalytics, session: Session);
    configure(): void;
    construct<T>(Type: Constructable<T>): T;
}
export {};
//# sourceMappingURL=config.d.ts.map