import { css } from '@microsoft/fast-element';
/**
 * Defines the css of the entity component as an ElementStyles object
 *
 * @remarks
 *
 * Mixin to custom ElementStyles to override and customise the style of an
 * entity manager component
 */
export const styles = css `
  :host {
    contain: content;
  }

  :host::part(header) {
    display: flex;
    justify-content: space-between;
    align-items: center;
    user-select: none;
  }

  :host([modal-position='centre']) .edit-modal {
    overflow-y: auto;
  }

  .container {
    display: flex;
    flex-direction: column;
    height: 100%;
  }

  foundation-form {
    height: 100%;
    overflow-y: auto;
    display: flex;
    flex-direction: column;
    justify-content: space-between;
  }

  .title {
    margin-left: 1px;
  }

  .header-title {
    color: var(--neutral-foreground-rest);
    font-size: var(--type-ramp-plus-4-font-size);
    font-family: var(--body-font);
    font-weight: 700;
    padding-left: calc(var(--design-unit) * 2px);
  }

  .search-container {
    display: flex;
    align-items: center;
    gap: calc(var(--design-unit) * 2px);
  }

  .search-container zero-search-bar,
  .search-container rapid-search-bar {
    width: 500px;
  }

  .add-button {
    margin-right: calc(var(--design-unit) * 2px);
  }
`;
