## API Report File for "@genesislcap/foundation-entity-management"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { Auth } from '@genesislcap/foundation-comms';
import { AvailableOption } from '@genesislcap/foundation-ui';
import { ColDef } from '@ag-grid-community/core';
import type { ColGroupDef } from '@ag-grid-community/core';
import { Connect } from '@genesislcap/foundation-comms';
import { Constructable } from '@microsoft/fast-element';
import { Container } from '@microsoft/fast-foundation';
import { Controller } from '@microsoft/fast-element';
import { DatasourceOptions } from '@genesislcap/foundation-comms';
import { DOMContainer } from '@genesislcap/foundation-utils';
import { FASTElement } from '@microsoft/fast-element';
import { FoundationAnalytics } from '@genesislcap/foundation-comms';
import { FoundationLayoutContainer } from '@genesislcap/foundation-utils';
import { GridOptions } from '@ag-grid-community/core';
import type { GridProCaseType } from '@genesislcap/grid-pro';
import { GridProRendererTypes } from '@genesislcap/foundation-zero-grid-pro';
import { LayoutCacheContainer } from '@genesislcap/foundation-utils';
import { Logger } from '@genesislcap/foundation-logger';
import type { Modal } from '@genesislcap/foundation-ui';
import { PartialFASTElementDefinition } from '@microsoft/fast-element';
import { RendererEntry } from '@genesislcap/foundation-forms';
import { RouterConfiguration } from '@microsoft/fast-router';
import { SelectedOption } from '@genesislcap/foundation-ui';
import { Session } from '@genesislcap/foundation-comms';
import { UiSchema } from '@genesislcap/foundation-forms';
import { ViewTemplate } from '@microsoft/fast-element';

// @public (undocumented)
export const buttonCellRenderer: (title: any, clickHandler: any, contentTemplate: any) => ColDef;

// @public
export type DatasourceConfiguration = Omit<DatasourceOptions, 'resourceName'>;

// Warning: (ae-internal-missing-underscore) The name "DynamicTemplate" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const DynamicTemplate: ViewTemplate<MainApplication>;

// Warning: (ae-forgotten-export) The symbol "EntityManagement_base" needs to be exported by the entry point index.d.ts
//
// @public
export class EntityManagement extends EntityManagement_base {
    asyncAdd: boolean;
    asyncRemove: boolean;
    asyncUpdate: boolean;
    // (undocumented)
    closeModal(): void;
    columns: ColDef[];
    // (undocumented)
    confirmDelete(): Promise<void>;
    protected connect: Connect;
    // @internal
    connectedCallback(): Promise<void>;
    // @internal
    createEntity(): void;
    createEvent: string;
    // (undocumented)
    createFormUiSchema: UiSchema;
    // (undocumented)
    criteriaChanged(e: CustomEvent<string>): void;
    datasourceConfig: DatasourceConfiguration;
    deepClone(): Node;
    defaultEntityValues: Record<string, unknown>;
    // @internal
    deleteEntity(e: CustomEvent): Promise<void>;
    deleteEvent: string;
    // (undocumented)
    disconnectedCallback(): Promise<void>;
    editDialogTitle: string;
    editedEntity: Record<string, unknown>;
    // (undocumented)
    editEntityModal: Modal;
    // (undocumented)
    editModalVisible: boolean;
    // (undocumented)
    editModalVisibleChanged(): void;
    enableCellFlashing: boolean;
    // (undocumented)
    enableFilterBar: boolean;
    enableRowFlashing: boolean;
    enableSearchBar: boolean;
    entityLabel: string;
    // @internal
    errorNotify(request: any): void;
    formRenderers: RendererEntry[];
    // @internal
    formResourceName: string;
    // (undocumented)
    formUiSchema: UiSchema;
    gridOptions: GridOptions;
    headerCaseType: GridProCaseType;
    // (undocumented)
    get headerTempalate(): ViewTemplate<EntityManagement, any>;
    // (undocumented)
    hideDelete: boolean;
    // (undocumented)
    hideEdit: boolean;
    modalPosition: 'centre' | 'left' | 'right';
    persistColumnStateKey: string;
    prefix: string;
    // (undocumented)
    readEvent: string;
    // (undocumented)
    readEventFn: (...args: any[]) => {};
    // (undocumented)
    readonly: boolean;
    // (undocumented)
    requestChanged(e: CustomEvent<string>): void;
    resourceName: string;
    rowSelection: string;
    // (undocumented)
    searchBarConfig: AvailableOption[];
    // (undocumented)
    searchBarDataserver(options: SelectedOption<string>[]): void;
    // (undocumented)
    searchBarReqServer(options: SelectedOption<string>[]): void;
    // (undocumented)
    searchChanged(event: CustomEvent<Array<SelectedOption>>): void;
    selectedEntity: Record<string, unknown>;
    // (undocumented)
    sizeColumnsToFit: boolean;
    submitEntityChanges(e: CustomEvent): Promise<void>;
    // (undocumented)
    submitFailureNotification(e: CustomEvent): void;
    // (undocumented)
    submitting: boolean;
    title: string;
    updateEvent: string;
    // (undocumented)
    updateFormUiSchema: UiSchema;
}

// @public
export const getErrorFormat: (err: any) => string;

// Warning: (ae-internal-missing-underscore) The name "LoadingTemplate" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const LoadingTemplate: ViewTemplate<MainApplication>;

// @public (undocumented)
export const logger: Logger;

// @public (undocumented)
export class MainApplication extends FASTElement {
    // Warning: (ae-forgotten-export) The symbol "MainRouterConfig" needs to be exported by the entry point index.d.ts
    //
    // (undocumented)
    config: MainRouterConfig;
    // (undocumented)
    connect: Connect;
    // (undocumented)
    connectedCallback(): void;
    // (undocumented)
    container: Container;
    // (undocumented)
    loadRemotes(): Promise<void>;
    // (undocumented)
    onLuminanceToggle(): void;
    // (undocumented)
    provider: HTMLElement;
    // (undocumented)
    ready: boolean;
    // (undocumented)
    selectTemplate(): ViewTemplate<MainApplication, any>;
    // (undocumented)
    session: Session;
}

// Warning: (ae-internal-missing-underscore) The name "MainTemplate" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const MainTemplate: ViewTemplate<MainApplication>;

// @public @deprecated
export class Profiles extends EntityManagement {
    constructor();
    // (undocumented)
    confirmDelete(): Promise<void>;
    // (undocumented)
    readProfileData(profile: any): Promise<{
        RIGHT_CODES: any[];
        USER_NAMES: any[];
        NAME: any;
    }>;
}

// Warning: (ae-forgotten-export) The symbol "Users_base" needs to be exported by the entry point index.d.ts
//
// @public @deprecated
export class Users extends Users_base {
    constructor();
    // Warning: (ae-forgotten-export) The symbol "AdditionalEntry" needs to be exported by the entry point index.d.ts
    //
    // (undocumented)
    additionalCreateFields: AdditionalEntry[];
    // (undocumented)
    additionalUpdateFields: AdditionalEntry[];
    // (undocumented)
    allAccessType: boolean;
    // @internal
    availableEntitiesEndpoint: string;
    // @internal
    changeStatus(params: any): Promise<void>;
    columns: (ColDef<any> | ColGroupDef<any>)[];
    // (undocumented)
    connectedCallback(): Promise<void>;
    createEvent: string;
    // @internal
    datasourceConfig: DatasourceConfiguration;
    // (undocumented)
    deepClone(): Node;
    deleteEvent: string;
    // (undocumented)
    disconnectedCallback(): Promise<void>;
    enableSearchBar: boolean;
    // @internal
    entityColumn(): {
        headerName: string;
        field: string;
        enableCellChangeFlash: boolean;
    }[];
    // @internal
    entityID: string;
    // @internal
    entityLabel: string;
    // @internal
    entityLabelKey: string;
    gridOptions: GridOptions;
    persistColumnStateKey: string;
    prefix: string;
    // @internal (undocumented)
    readUserData(user: any): Promise<{
        USER_PROFILES: any[];
        ADDRESS_LINE_1: any;
        ADDRESS_LINE_2: any;
        ADDRESS_LINE_3: any;
        ADDRESS_LINE_4: any;
        ACCESS_TYPE: string;
    } | {
        USER_PROFILES: any[];
        ADDRESS_LINE_1: any;
        ADDRESS_LINE_2: any;
        ADDRESS_LINE_3: any;
        ADDRESS_LINE_4: any;
        ACCESS_TYPE?: undefined;
    }>;
    // @internal
    resourceName: string;
    // @internal
    statusColumn(): {
        headerName: string;
        field: string;
        minWidth: number;
        width: number;
        suppressSizeToFit: boolean;
        cellRendererSelector: any;
        enableCellChangeFlash: boolean;
    };
    // @internal
    statusRendererSelector(params: any): {
        component: GridProRendererTypes;
        params: {
            actionClick: () => Promise<void>;
            actionName: string;
            appearance: string;
        };
    };
    updateEvent: string;
}

// @public
export const UsersColumnConfig: ({
    field: string;
    headerName: string;
    enableCellChangeFlash: boolean;
} | {
    field: string;
    headerName: string;
    valueFormatter: ({ value }: {
        value: any;
    }) => string;
    enableCellChangeFlash: boolean;
})[];

// (No @packageDocumentation comment for this package)

```
