<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-entity-management](./foundation-entity-management.md) &gt; [Users](./foundation-entity-management.users.md)

## Users class

> Warning: This API is now obsolete.
> 
> - Use '<!-- -->@<!-- -->genesislcap/pbc-auth' instead. 'https://www.npmjs.com/package/<!-- -->@<!-- -->genesislcap/pbc-auth'
> 

Main class which defines the user management functionality

**Signature:**

```typescript
export declare class Users extends Users_base 
```
**Extends:** Users\_base

## Remarks

Under the hood the user-management is the entity-management micro-frontend configured for use with the `ALL_USERS` resource.

## Example

With no customisation required the user management micro-frontend can simply be dropped into the template as shown. However, it is advised to wrap it in an error boundary component.

```javascript
<user-management></user-management>
```
With this default example above the columns will be the [UsersColumnConfig](./foundation-entity-management.userscolumnconfig.md) as well as the entity and status columns. The entity and status columns are always added regardless of the other columns which are configured.

You can add in additional customisation options. For example you can define a custom column and then mix-in with the standard columns

```javascript
import { Users, UsersColumnConfig, } from '@genesislcap/foundation-entity-management';

const userColumns = [
  {
    field: 'ACCESS_TYPE',
    headerName: 'Access Type',
  },
];

// Definition inside of the html template
<user-management :columns=${() => [...UsersColumnConfig, ...userColumns]}></user-management>
```

## Constructors

|  Constructor | Modifiers | Description |
|  --- | --- | --- |
|  [(constructor)()](./foundation-entity-management.users._constructor_.md) |  | Constructor will set the [Users.createEvent](./foundation-entity-management.users.createevent.md) [Users.deleteEvent](./foundation-entity-management.users.deleteevent.md) [Users.updateEvent](./foundation-entity-management.users.updateevent.md) to match the permissions set from the server |

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [additionalCreateFields](./foundation-entity-management.users.additionalcreatefields.md) |  | AdditionalEntry\[\] |  |
|  [additionalUpdateFields](./foundation-entity-management.users.additionalupdatefields.md) |  | AdditionalEntry\[\] |  |
|  [allAccessType](./foundation-entity-management.users.allaccesstype.md) |  | boolean |  |
|  [columns](./foundation-entity-management.users.columns.md) |  | (ColDef&lt;any&gt; \| ColGroupDef&lt;any&gt;)\[\] | Column definition, default to the UsersColumnConfig |
|  [createEvent](./foundation-entity-management.users.createevent.md) |  | string | String which contains event if we have permission to insert user of empty string if not |
|  [deleteEvent](./foundation-entity-management.users.deleteevent.md) |  | string | String which contains event if we have permission to delete user of empty string if not |
|  [enableSearchBar](./foundation-entity-management.users.enablesearchbar.md) |  | boolean | This attribute controls whether to enable the search-bar. |
|  [gridOptions](./foundation-entity-management.users.gridoptions.md) |  | GridOptions | GridOptions to be passed down from application |
|  [persistColumnStateKey](./foundation-entity-management.users.persistcolumnstatekey.md) |  | string | This attribute controls whether and how the user manager stores the state of the columns when the user edits them. Defaulted to <code>entity_users_management</code>. |
|  [prefix](./foundation-entity-management.users.prefix.md) |  | string | Name of the design system prefix that will be used for components. |
|  [updateEvent](./foundation-entity-management.users.updateevent.md) |  | string | String which contains event if we have permission to update user of empty string if not |

## Methods

|  Method | Modifiers | Description |
|  --- | --- | --- |
|  [connectedCallback()](./foundation-entity-management.users.connectedcallback.md) |  |  |
|  [deepClone()](./foundation-entity-management.users.deepclone.md) |  |  |
|  [disconnectedCallback()](./foundation-entity-management.users.disconnectedcallback.md) |  |  |

