import { LoginPage } from '@genesislcap/foundation-login/e2e';
import {
  test as base,
  TestFixture as BaseTestFixture,
  WorkerFixture as BaseWorkerFixture,
} from '@genesislcap/foundation-testing/e2e';
import { EntityManagementPage } from './pages';

export type TestFixture = BaseTestFixture & {
  EntityManagementPage: EntityManagementPage;
};

export type WorkerFixture = BaseWorkerFixture & {};

export const test = base.extend<TestFixture, WorkerFixture>({
  entityManagementPage: async ({ config, port, page }, use) => {
    const entityManagementPage = new EntityManagementPage(config, port, page);
    await entityManagementPage.goto();
    await use(entityManagementPage);
  },
  loginPage: async ({ config, port, page }, use) => {
    const loginPage = new LoginPage(config, port, page);
    await loginPage.goto();
    await use(loginPage);
  },
});
